// Code generated by MockGen. DO NOT EDIT.
// Source: k8s.io/apiextensions-apiserver/pkg/client/clientset/clientset/typed/apiextensions/v1 (interfaces: ApiextensionsV1Interface,CustomResourceDefinitionInterface)
//
// Generated by this command:
//
//	mockgen -typed -destination apiextensionclient_v1.go -package mock_k8s k8s.io/apiextensions-apiserver/pkg/client/clientset/clientset/typed/apiextensions/v1 ApiextensionsV1Interface,CustomResourceDefinitionInterface
//

// Package mock_k8s is a generated GoMock package.
package mock_k8s

import (
	context "context"
	reflect "reflect"

	gomock "go.uber.org/mock/gomock"
	v1 "k8s.io/apiextensions-apiserver/pkg/apis/apiextensions/v1"
	v10 "k8s.io/apiextensions-apiserver/pkg/client/applyconfiguration/apiextensions/v1"
	v11 "k8s.io/apiextensions-apiserver/pkg/client/clientset/clientset/typed/apiextensions/v1"
	v12 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// MockApiextensionsV1Interface is a mock of ApiextensionsV1Interface interface.
type MockApiextensionsV1Interface struct {
	ctrl     *gomock.Controller
	recorder *MockApiextensionsV1InterfaceMockRecorder
}

// MockApiextensionsV1InterfaceMockRecorder is the mock recorder for MockApiextensionsV1Interface.
type MockApiextensionsV1InterfaceMockRecorder struct {
	mock *MockApiextensionsV1Interface
}

// NewMockApiextensionsV1Interface creates a new mock instance.
func NewMockApiextensionsV1Interface(ctrl *gomock.Controller) *MockApiextensionsV1Interface {
	mock := &MockApiextensionsV1Interface{ctrl: ctrl}
	mock.recorder = &MockApiextensionsV1InterfaceMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockApiextensionsV1Interface) EXPECT() *MockApiextensionsV1InterfaceMockRecorder {
	return m.recorder
}

// CustomResourceDefinitions mocks base method.
func (m *MockApiextensionsV1Interface) CustomResourceDefinitions() v11.CustomResourceDefinitionInterface {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "CustomResourceDefinitions")
	ret0, _ := ret[0].(v11.CustomResourceDefinitionInterface)
	return ret0
}

// CustomResourceDefinitions indicates an expected call of CustomResourceDefinitions.
func (mr *MockApiextensionsV1InterfaceMockRecorder) CustomResourceDefinitions() *MockApiextensionsV1InterfaceCustomResourceDefinitionsCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "CustomResourceDefinitions", reflect.TypeOf((*MockApiextensionsV1Interface)(nil).CustomResourceDefinitions))
	return &MockApiextensionsV1InterfaceCustomResourceDefinitionsCall{Call: call}
}

// MockApiextensionsV1InterfaceCustomResourceDefinitionsCall wrap *gomock.Call
type MockApiextensionsV1InterfaceCustomResourceDefinitionsCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockApiextensionsV1InterfaceCustomResourceDefinitionsCall) Return(arg0 v11.CustomResourceDefinitionInterface) *MockApiextensionsV1InterfaceCustomResourceDefinitionsCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockApiextensionsV1InterfaceCustomResourceDefinitionsCall) Do(f func() v11.CustomResourceDefinitionInterface) *MockApiextensionsV1InterfaceCustomResourceDefinitionsCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockApiextensionsV1InterfaceCustomResourceDefinitionsCall) DoAndReturn(f func() v11.CustomResourceDefinitionInterface) *MockApiextensionsV1InterfaceCustomResourceDefinitionsCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// RESTClient mocks base method.
func (m *MockApiextensionsV1Interface) RESTClient() rest.Interface {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "RESTClient")
	ret0, _ := ret[0].(rest.Interface)
	return ret0
}

// RESTClient indicates an expected call of RESTClient.
func (mr *MockApiextensionsV1InterfaceMockRecorder) RESTClient() *MockApiextensionsV1InterfaceRESTClientCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "RESTClient", reflect.TypeOf((*MockApiextensionsV1Interface)(nil).RESTClient))
	return &MockApiextensionsV1InterfaceRESTClientCall{Call: call}
}

// MockApiextensionsV1InterfaceRESTClientCall wrap *gomock.Call
type MockApiextensionsV1InterfaceRESTClientCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockApiextensionsV1InterfaceRESTClientCall) Return(arg0 rest.Interface) *MockApiextensionsV1InterfaceRESTClientCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockApiextensionsV1InterfaceRESTClientCall) Do(f func() rest.Interface) *MockApiextensionsV1InterfaceRESTClientCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockApiextensionsV1InterfaceRESTClientCall) DoAndReturn(f func() rest.Interface) *MockApiextensionsV1InterfaceRESTClientCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// MockCustomResourceDefinitionInterface is a mock of CustomResourceDefinitionInterface interface.
type MockCustomResourceDefinitionInterface struct {
	ctrl     *gomock.Controller
	recorder *MockCustomResourceDefinitionInterfaceMockRecorder
}

// MockCustomResourceDefinitionInterfaceMockRecorder is the mock recorder for MockCustomResourceDefinitionInterface.
type MockCustomResourceDefinitionInterfaceMockRecorder struct {
	mock *MockCustomResourceDefinitionInterface
}

// NewMockCustomResourceDefinitionInterface creates a new mock instance.
func NewMockCustomResourceDefinitionInterface(ctrl *gomock.Controller) *MockCustomResourceDefinitionInterface {
	mock := &MockCustomResourceDefinitionInterface{ctrl: ctrl}
	mock.recorder = &MockCustomResourceDefinitionInterfaceMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockCustomResourceDefinitionInterface) EXPECT() *MockCustomResourceDefinitionInterfaceMockRecorder {
	return m.recorder
}

// Apply mocks base method.
func (m *MockCustomResourceDefinitionInterface) Apply(arg0 context.Context, arg1 *v10.CustomResourceDefinitionApplyConfiguration, arg2 v12.ApplyOptions) (*v1.CustomResourceDefinition, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Apply", arg0, arg1, arg2)
	ret0, _ := ret[0].(*v1.CustomResourceDefinition)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// Apply indicates an expected call of Apply.
func (mr *MockCustomResourceDefinitionInterfaceMockRecorder) Apply(arg0, arg1, arg2 any) *MockCustomResourceDefinitionInterfaceApplyCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Apply", reflect.TypeOf((*MockCustomResourceDefinitionInterface)(nil).Apply), arg0, arg1, arg2)
	return &MockCustomResourceDefinitionInterfaceApplyCall{Call: call}
}

// MockCustomResourceDefinitionInterfaceApplyCall wrap *gomock.Call
type MockCustomResourceDefinitionInterfaceApplyCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockCustomResourceDefinitionInterfaceApplyCall) Return(arg0 *v1.CustomResourceDefinition, arg1 error) *MockCustomResourceDefinitionInterfaceApplyCall {
	c.Call = c.Call.Return(arg0, arg1)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockCustomResourceDefinitionInterfaceApplyCall) Do(f func(context.Context, *v10.CustomResourceDefinitionApplyConfiguration, v12.ApplyOptions) (*v1.CustomResourceDefinition, error)) *MockCustomResourceDefinitionInterfaceApplyCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockCustomResourceDefinitionInterfaceApplyCall) DoAndReturn(f func(context.Context, *v10.CustomResourceDefinitionApplyConfiguration, v12.ApplyOptions) (*v1.CustomResourceDefinition, error)) *MockCustomResourceDefinitionInterfaceApplyCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// ApplyStatus mocks base method.
func (m *MockCustomResourceDefinitionInterface) ApplyStatus(arg0 context.Context, arg1 *v10.CustomResourceDefinitionApplyConfiguration, arg2 v12.ApplyOptions) (*v1.CustomResourceDefinition, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "ApplyStatus", arg0, arg1, arg2)
	ret0, _ := ret[0].(*v1.CustomResourceDefinition)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// ApplyStatus indicates an expected call of ApplyStatus.
func (mr *MockCustomResourceDefinitionInterfaceMockRecorder) ApplyStatus(arg0, arg1, arg2 any) *MockCustomResourceDefinitionInterfaceApplyStatusCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "ApplyStatus", reflect.TypeOf((*MockCustomResourceDefinitionInterface)(nil).ApplyStatus), arg0, arg1, arg2)
	return &MockCustomResourceDefinitionInterfaceApplyStatusCall{Call: call}
}

// MockCustomResourceDefinitionInterfaceApplyStatusCall wrap *gomock.Call
type MockCustomResourceDefinitionInterfaceApplyStatusCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockCustomResourceDefinitionInterfaceApplyStatusCall) Return(arg0 *v1.CustomResourceDefinition, arg1 error) *MockCustomResourceDefinitionInterfaceApplyStatusCall {
	c.Call = c.Call.Return(arg0, arg1)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockCustomResourceDefinitionInterfaceApplyStatusCall) Do(f func(context.Context, *v10.CustomResourceDefinitionApplyConfiguration, v12.ApplyOptions) (*v1.CustomResourceDefinition, error)) *MockCustomResourceDefinitionInterfaceApplyStatusCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockCustomResourceDefinitionInterfaceApplyStatusCall) DoAndReturn(f func(context.Context, *v10.CustomResourceDefinitionApplyConfiguration, v12.ApplyOptions) (*v1.CustomResourceDefinition, error)) *MockCustomResourceDefinitionInterfaceApplyStatusCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// Create mocks base method.
func (m *MockCustomResourceDefinitionInterface) Create(arg0 context.Context, arg1 *v1.CustomResourceDefinition, arg2 v12.CreateOptions) (*v1.CustomResourceDefinition, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Create", arg0, arg1, arg2)
	ret0, _ := ret[0].(*v1.CustomResourceDefinition)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// Create indicates an expected call of Create.
func (mr *MockCustomResourceDefinitionInterfaceMockRecorder) Create(arg0, arg1, arg2 any) *MockCustomResourceDefinitionInterfaceCreateCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Create", reflect.TypeOf((*MockCustomResourceDefinitionInterface)(nil).Create), arg0, arg1, arg2)
	return &MockCustomResourceDefinitionInterfaceCreateCall{Call: call}
}

// MockCustomResourceDefinitionInterfaceCreateCall wrap *gomock.Call
type MockCustomResourceDefinitionInterfaceCreateCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockCustomResourceDefinitionInterfaceCreateCall) Return(arg0 *v1.CustomResourceDefinition, arg1 error) *MockCustomResourceDefinitionInterfaceCreateCall {
	c.Call = c.Call.Return(arg0, arg1)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockCustomResourceDefinitionInterfaceCreateCall) Do(f func(context.Context, *v1.CustomResourceDefinition, v12.CreateOptions) (*v1.CustomResourceDefinition, error)) *MockCustomResourceDefinitionInterfaceCreateCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockCustomResourceDefinitionInterfaceCreateCall) DoAndReturn(f func(context.Context, *v1.CustomResourceDefinition, v12.CreateOptions) (*v1.CustomResourceDefinition, error)) *MockCustomResourceDefinitionInterfaceCreateCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// Delete mocks base method.
func (m *MockCustomResourceDefinitionInterface) Delete(arg0 context.Context, arg1 string, arg2 v12.DeleteOptions) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Delete", arg0, arg1, arg2)
	ret0, _ := ret[0].(error)
	return ret0
}

// Delete indicates an expected call of Delete.
func (mr *MockCustomResourceDefinitionInterfaceMockRecorder) Delete(arg0, arg1, arg2 any) *MockCustomResourceDefinitionInterfaceDeleteCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Delete", reflect.TypeOf((*MockCustomResourceDefinitionInterface)(nil).Delete), arg0, arg1, arg2)
	return &MockCustomResourceDefinitionInterfaceDeleteCall{Call: call}
}

// MockCustomResourceDefinitionInterfaceDeleteCall wrap *gomock.Call
type MockCustomResourceDefinitionInterfaceDeleteCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockCustomResourceDefinitionInterfaceDeleteCall) Return(arg0 error) *MockCustomResourceDefinitionInterfaceDeleteCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockCustomResourceDefinitionInterfaceDeleteCall) Do(f func(context.Context, string, v12.DeleteOptions) error) *MockCustomResourceDefinitionInterfaceDeleteCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockCustomResourceDefinitionInterfaceDeleteCall) DoAndReturn(f func(context.Context, string, v12.DeleteOptions) error) *MockCustomResourceDefinitionInterfaceDeleteCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// DeleteCollection mocks base method.
func (m *MockCustomResourceDefinitionInterface) DeleteCollection(arg0 context.Context, arg1 v12.DeleteOptions, arg2 v12.ListOptions) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "DeleteCollection", arg0, arg1, arg2)
	ret0, _ := ret[0].(error)
	return ret0
}

// DeleteCollection indicates an expected call of DeleteCollection.
func (mr *MockCustomResourceDefinitionInterfaceMockRecorder) DeleteCollection(arg0, arg1, arg2 any) *MockCustomResourceDefinitionInterfaceDeleteCollectionCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "DeleteCollection", reflect.TypeOf((*MockCustomResourceDefinitionInterface)(nil).DeleteCollection), arg0, arg1, arg2)
	return &MockCustomResourceDefinitionInterfaceDeleteCollectionCall{Call: call}
}

// MockCustomResourceDefinitionInterfaceDeleteCollectionCall wrap *gomock.Call
type MockCustomResourceDefinitionInterfaceDeleteCollectionCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockCustomResourceDefinitionInterfaceDeleteCollectionCall) Return(arg0 error) *MockCustomResourceDefinitionInterfaceDeleteCollectionCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockCustomResourceDefinitionInterfaceDeleteCollectionCall) Do(f func(context.Context, v12.DeleteOptions, v12.ListOptions) error) *MockCustomResourceDefinitionInterfaceDeleteCollectionCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockCustomResourceDefinitionInterfaceDeleteCollectionCall) DoAndReturn(f func(context.Context, v12.DeleteOptions, v12.ListOptions) error) *MockCustomResourceDefinitionInterfaceDeleteCollectionCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// Get mocks base method.
func (m *MockCustomResourceDefinitionInterface) Get(arg0 context.Context, arg1 string, arg2 v12.GetOptions) (*v1.CustomResourceDefinition, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Get", arg0, arg1, arg2)
	ret0, _ := ret[0].(*v1.CustomResourceDefinition)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// Get indicates an expected call of Get.
func (mr *MockCustomResourceDefinitionInterfaceMockRecorder) Get(arg0, arg1, arg2 any) *MockCustomResourceDefinitionInterfaceGetCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Get", reflect.TypeOf((*MockCustomResourceDefinitionInterface)(nil).Get), arg0, arg1, arg2)
	return &MockCustomResourceDefinitionInterfaceGetCall{Call: call}
}

// MockCustomResourceDefinitionInterfaceGetCall wrap *gomock.Call
type MockCustomResourceDefinitionInterfaceGetCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockCustomResourceDefinitionInterfaceGetCall) Return(arg0 *v1.CustomResourceDefinition, arg1 error) *MockCustomResourceDefinitionInterfaceGetCall {
	c.Call = c.Call.Return(arg0, arg1)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockCustomResourceDefinitionInterfaceGetCall) Do(f func(context.Context, string, v12.GetOptions) (*v1.CustomResourceDefinition, error)) *MockCustomResourceDefinitionInterfaceGetCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockCustomResourceDefinitionInterfaceGetCall) DoAndReturn(f func(context.Context, string, v12.GetOptions) (*v1.CustomResourceDefinition, error)) *MockCustomResourceDefinitionInterfaceGetCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// List mocks base method.
func (m *MockCustomResourceDefinitionInterface) List(arg0 context.Context, arg1 v12.ListOptions) (*v1.CustomResourceDefinitionList, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "List", arg0, arg1)
	ret0, _ := ret[0].(*v1.CustomResourceDefinitionList)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// List indicates an expected call of List.
func (mr *MockCustomResourceDefinitionInterfaceMockRecorder) List(arg0, arg1 any) *MockCustomResourceDefinitionInterfaceListCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "List", reflect.TypeOf((*MockCustomResourceDefinitionInterface)(nil).List), arg0, arg1)
	return &MockCustomResourceDefinitionInterfaceListCall{Call: call}
}

// MockCustomResourceDefinitionInterfaceListCall wrap *gomock.Call
type MockCustomResourceDefinitionInterfaceListCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockCustomResourceDefinitionInterfaceListCall) Return(arg0 *v1.CustomResourceDefinitionList, arg1 error) *MockCustomResourceDefinitionInterfaceListCall {
	c.Call = c.Call.Return(arg0, arg1)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockCustomResourceDefinitionInterfaceListCall) Do(f func(context.Context, v12.ListOptions) (*v1.CustomResourceDefinitionList, error)) *MockCustomResourceDefinitionInterfaceListCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockCustomResourceDefinitionInterfaceListCall) DoAndReturn(f func(context.Context, v12.ListOptions) (*v1.CustomResourceDefinitionList, error)) *MockCustomResourceDefinitionInterfaceListCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// Patch mocks base method.
func (m *MockCustomResourceDefinitionInterface) Patch(arg0 context.Context, arg1 string, arg2 types.PatchType, arg3 []byte, arg4 v12.PatchOptions, arg5 ...string) (*v1.CustomResourceDefinition, error) {
	m.ctrl.T.Helper()
	varargs := []any{arg0, arg1, arg2, arg3, arg4}
	for _, a := range arg5 {
		varargs = append(varargs, a)
	}
	ret := m.ctrl.Call(m, "Patch", varargs...)
	ret0, _ := ret[0].(*v1.CustomResourceDefinition)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// Patch indicates an expected call of Patch.
func (mr *MockCustomResourceDefinitionInterfaceMockRecorder) Patch(arg0, arg1, arg2, arg3, arg4 any, arg5 ...any) *MockCustomResourceDefinitionInterfacePatchCall {
	mr.mock.ctrl.T.Helper()
	varargs := append([]any{arg0, arg1, arg2, arg3, arg4}, arg5...)
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Patch", reflect.TypeOf((*MockCustomResourceDefinitionInterface)(nil).Patch), varargs...)
	return &MockCustomResourceDefinitionInterfacePatchCall{Call: call}
}

// MockCustomResourceDefinitionInterfacePatchCall wrap *gomock.Call
type MockCustomResourceDefinitionInterfacePatchCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockCustomResourceDefinitionInterfacePatchCall) Return(arg0 *v1.CustomResourceDefinition, arg1 error) *MockCustomResourceDefinitionInterfacePatchCall {
	c.Call = c.Call.Return(arg0, arg1)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockCustomResourceDefinitionInterfacePatchCall) Do(f func(context.Context, string, types.PatchType, []byte, v12.PatchOptions, ...string) (*v1.CustomResourceDefinition, error)) *MockCustomResourceDefinitionInterfacePatchCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockCustomResourceDefinitionInterfacePatchCall) DoAndReturn(f func(context.Context, string, types.PatchType, []byte, v12.PatchOptions, ...string) (*v1.CustomResourceDefinition, error)) *MockCustomResourceDefinitionInterfacePatchCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// Update mocks base method.
func (m *MockCustomResourceDefinitionInterface) Update(arg0 context.Context, arg1 *v1.CustomResourceDefinition, arg2 v12.UpdateOptions) (*v1.CustomResourceDefinition, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Update", arg0, arg1, arg2)
	ret0, _ := ret[0].(*v1.CustomResourceDefinition)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// Update indicates an expected call of Update.
func (mr *MockCustomResourceDefinitionInterfaceMockRecorder) Update(arg0, arg1, arg2 any) *MockCustomResourceDefinitionInterfaceUpdateCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Update", reflect.TypeOf((*MockCustomResourceDefinitionInterface)(nil).Update), arg0, arg1, arg2)
	return &MockCustomResourceDefinitionInterfaceUpdateCall{Call: call}
}

// MockCustomResourceDefinitionInterfaceUpdateCall wrap *gomock.Call
type MockCustomResourceDefinitionInterfaceUpdateCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockCustomResourceDefinitionInterfaceUpdateCall) Return(arg0 *v1.CustomResourceDefinition, arg1 error) *MockCustomResourceDefinitionInterfaceUpdateCall {
	c.Call = c.Call.Return(arg0, arg1)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockCustomResourceDefinitionInterfaceUpdateCall) Do(f func(context.Context, *v1.CustomResourceDefinition, v12.UpdateOptions) (*v1.CustomResourceDefinition, error)) *MockCustomResourceDefinitionInterfaceUpdateCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockCustomResourceDefinitionInterfaceUpdateCall) DoAndReturn(f func(context.Context, *v1.CustomResourceDefinition, v12.UpdateOptions) (*v1.CustomResourceDefinition, error)) *MockCustomResourceDefinitionInterfaceUpdateCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// UpdateStatus mocks base method.
func (m *MockCustomResourceDefinitionInterface) UpdateStatus(arg0 context.Context, arg1 *v1.CustomResourceDefinition, arg2 v12.UpdateOptions) (*v1.CustomResourceDefinition, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "UpdateStatus", arg0, arg1, arg2)
	ret0, _ := ret[0].(*v1.CustomResourceDefinition)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// UpdateStatus indicates an expected call of UpdateStatus.
func (mr *MockCustomResourceDefinitionInterfaceMockRecorder) UpdateStatus(arg0, arg1, arg2 any) *MockCustomResourceDefinitionInterfaceUpdateStatusCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "UpdateStatus", reflect.TypeOf((*MockCustomResourceDefinitionInterface)(nil).UpdateStatus), arg0, arg1, arg2)
	return &MockCustomResourceDefinitionInterfaceUpdateStatusCall{Call: call}
}

// MockCustomResourceDefinitionInterfaceUpdateStatusCall wrap *gomock.Call
type MockCustomResourceDefinitionInterfaceUpdateStatusCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockCustomResourceDefinitionInterfaceUpdateStatusCall) Return(arg0 *v1.CustomResourceDefinition, arg1 error) *MockCustomResourceDefinitionInterfaceUpdateStatusCall {
	c.Call = c.Call.Return(arg0, arg1)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockCustomResourceDefinitionInterfaceUpdateStatusCall) Do(f func(context.Context, *v1.CustomResourceDefinition, v12.UpdateOptions) (*v1.CustomResourceDefinition, error)) *MockCustomResourceDefinitionInterfaceUpdateStatusCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockCustomResourceDefinitionInterfaceUpdateStatusCall) DoAndReturn(f func(context.Context, *v1.CustomResourceDefinition, v12.UpdateOptions) (*v1.CustomResourceDefinition, error)) *MockCustomResourceDefinitionInterfaceUpdateStatusCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// Watch mocks base method.
func (m *MockCustomResourceDefinitionInterface) Watch(arg0 context.Context, arg1 v12.ListOptions) (watch.Interface, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Watch", arg0, arg1)
	ret0, _ := ret[0].(watch.Interface)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// Watch indicates an expected call of Watch.
func (mr *MockCustomResourceDefinitionInterfaceMockRecorder) Watch(arg0, arg1 any) *MockCustomResourceDefinitionInterfaceWatchCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Watch", reflect.TypeOf((*MockCustomResourceDefinitionInterface)(nil).Watch), arg0, arg1)
	return &MockCustomResourceDefinitionInterfaceWatchCall{Call: call}
}

// MockCustomResourceDefinitionInterfaceWatchCall wrap *gomock.Call
type MockCustomResourceDefinitionInterfaceWatchCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockCustomResourceDefinitionInterfaceWatchCall) Return(arg0 watch.Interface, arg1 error) *MockCustomResourceDefinitionInterfaceWatchCall {
	c.Call = c.Call.Return(arg0, arg1)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockCustomResourceDefinitionInterfaceWatchCall) Do(f func(context.Context, v12.ListOptions) (watch.Interface, error)) *MockCustomResourceDefinitionInterfaceWatchCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockCustomResourceDefinitionInterfaceWatchCall) DoAndReturn(f func(context.Context, v12.ListOptions) (watch.Interface, error)) *MockCustomResourceDefinitionInterfaceWatchCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}
